Name:           ensmallen
Version:        1.16.2
Release:        1%{?dist}
Summary:        Header-only C++ library for efficient mathematical optimization

License:        BSD
URL:            https://www.ensmallen.org
Source0:        https://www.ensmallen.org/files/%{name}-%{version}.tar.gz

BuildRequires:  cmake3
BuildRequires:	gcc-c++
BuildRequires:	armadillo-devel >= 6.500.0
Requires:       armadillo-devel >= 6.500.0

# ensmallen is header-only, and the build just builds the tests, so there's no
# use for a debuginfo package.
%global debug_package %{nil}

%description
ensmallen is a header-only C++ library for efficient mathematical optimization.
It provides a simple set of abstractions for writing an objective function to
optimize. It also provides a large set of standard and cutting-edge optimizers
that can be used for virtually any mathematical optimization task.  These
include full-batch gradient descent techniques, small-batch techniques,
gradient-free optimizers, and constrained optimization.

%prep
%autosetup

%build
%cmake3

# Technically we don't need to build anything but it's a good sanity check to
# just build the tests to make sure they compile.
%make_build

%install
%make_install

%check
# Disable the SmallLovaszThetaSdp test---it exposes a bug in one of ensmallen's
# dependencies.
./ensmallen_tests ~SmallLovaszThetaSdp

%package devel
Summary:  Header-only C++ library for efficient mathematical optimization
Provides: ensmallen-static = %{version}-%{release}

%description devel
ensmallen is a header-only C++ library for efficient mathematical optimization.
It provides a simple set of abstractions for writing an objective function to
optimize. It also provides a large set of standard and cutting-edge optimizers
that can be used for virtually any mathematical optimization task.  These
include full-batch gradient descent techniques, small-batch techniques,
gradient-free optimizers, and constrained optimization.

%files devel
%license LICENSE.txt
%{_includedir}/ensmallen.hpp
%{_includedir}/ensmallen_bits/

%changelog
* Fri Aug 16 2019 Ryan Curtin <ryan@ratml.org> - 1.16.2-1
- Update to latest stable version.

* Wed Jul 24 2019 Fedora Release Engineering <releng@fedoraproject.org> - 1.15.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Mon May 27 2019 Ryan Curtin <ryan@ratml.org> - 1.15.1-1
- Update to latest stable version.

* Mon May  6 2019 Ryan Curtin <ryan@ratml.org> - 1.14.2-1
- Initial packaging.
